Strict
Framework brl.standardio
Import brl.socketstream
Import pub.stdc
Import thunder.future

Function LoadHTTPHeaderWr:Object(o:Object)
	Return Object(loadhttpheader(String(o)))
EndFunction

Function LoadHTTPHeader:String(host:String)
	Const path:String = "/"
	
	Local sock:TSocket = TSocket.CreateTCP()
	If Not sock.connect(HostIp(host), 80) Then Return Null
	If Not sock.connected() Then Return Null

	Local stream:TSocketStream = TSocketStream.Create(sock)	
	If stream = Null Then Return Null
	Local r:String
	
	Try
		stream.WriteLine "GET "+path+" HTTP/1.1"
		stream.WriteLine "Host: "+host
		stream.WriteLine "Connection: close"
		stream.WriteLine ""

		While Not Eof(stream)
			Local s$ = ReadLine(stream)
			If s = "" Then Exit
			r:+s+"~n"
		Wend
	
	Catch e:Object
		stream.close
		Throw e
	EndTry
	
	stream.close
	
	Return r
EndFunction

Local time, s1:String, s2:String

time = MilliSecs()

Local webpages:Future[] = [	Future.Create(LoadHTTPHeaderWr, "www.cplusplus.com"), ..
							Future.Create(LoadHTTPHeaderWr, "www.gmx.net"), ..
							Future.Create(LoadHTTPHeaderWr, "www.blitzforum.de"), ..
							Future.Create(LoadHTTPHeaderWr, "www.heise.de"), ..
							Future.Create(LoadHTTPHeaderWr, "derstandard.at"), ..
							Future.Create(LoadHTTPHeaderWr, "de.wikipedia.org")]


For Local fut:Future = EachIn webpages
	Print "header of "+String(fut.getParameter())
	Print String(fut.get())
Next

time = MilliSecs() - time

Print "time = "+time+" ms"


