Strict
Module thunder.future
Import brl.threads

ModuleInfo "Version: 0.8"
ModuleInfo "Author: Christian Fiedler"
ModuleInfo "License: public domain"

ModuleInfo "History: 0.8 Release"
ModuleInfo "History: Added Future and CBFuture"

Include "cbfuture.bmx"

Type Future
	Field _returndata:Object = Null
	Field _parameter:Object = Null
	Field _error = 0
?Threaded
	Field _thread:TThread = Null
?

	Function BareCopy:Future(parameter:Object, returned:Object, error)
		Local fut:Future = New Future
		fut._parameter = parameter
		fut._returndata = returned
		fut._error = error
		Return fut
	EndFunction

	Function Create:Future(func:Object(blub:Object), o:Object, cb(f:Future) = Null)
		Local fut:Future = New Future
		fut._parameter = o
		Return fut._exec(func)
	EndFunction
	
	Method _exec:Future(func:Object(blub:Object))
?Threaded
		_thread = TThread.Create(func, _parameter)
		If _thread = Null Then _error = 1
?
		_returndata = func(_parameter)
?
		Return Self
	EndMethod
	
	Method getParameter:Object()
		Return _parameter
	EndMethod
	
	Method valid()
?Threaded
		Return _error = 0 And (_thread = Null Or Not _thread.running())
?
		Return _error = 0
?
	EndMethod
	
	Method bad()
		Return _error <> 0
	EndMethod
	
	Method wait()
?Threaded
		_returndata = _thread.wait()
?
	EndMethod
	
	Method get:Object()
		If Not valid() Then wait
		Return _returndata
	EndMethod
	
EndType
	